/*
* 
* Kirjeldus: 1) Sisestatakse pinusse massiivi A failist F1
*            2) Sisestatakse pinusse massiivi B failist F2
*            3) Sisestatakse klaviatuurilt reaalarv X
*            4) moodustatakse ja väljastatakse faili F3 massiiv K elementidega :=
*                   K0 = 1 , Ki = Ki-1 * Ai * Xˇi / ( Aiˇ2 + Biˇ2 ), i = 1 ... min(N,M)
*/

/*
Ei jõudnud valmis.
Tahtsin hiljem veel lisada dünaamilise mälujaotuse ka sisselugemisel ja samuti töötlusel.
töötlusel on veel mingi väikene viga sees
*/

#include <stdio.h>
#include <stdlib.h>

#define DEBUG 0

// globaalmuutujad
const char massiivAFailiNimi[] = "F1.txt";
const char massiivBFailiNimi[] = "F2.txt";
int i;  // korduste lugemiseks

// sisestus - sisestatakse kahest failist korraga massiivi
int sisestus( float * A, int * n, const char * massiiviNimi)
{
    FILE * fileA = fopen(massiiviNimi, "r");

    // kontroll
    if( fileA == NULL )
    {
        if( DEBUG == 1 ) printf("massiivi A ei saa sisse lugeda.\n");
        return 1;
    }

    // sisend
    i = 0;
    while( !feof(fileA) )
    {
        /*if( i >= *n ) // näitab, et tuleb mälu eraldada massiivi A
        {
            *n = *n + 3;
            float * temp = realloc( A , sizeof(float) * (*n) );
            if( temp == NULL )
            {
                printf("Ei õnnestunud mälu eraldada.\n");
                break;
            }
            A = temp;
        }*/

        fscanf(fileA,"%f", A + i);
        if(DEBUG == 1) printf("A %d => %f \n", i, *(A + i ));
        i++;
    }
    fclose(fileA);
    *n = i - 1;
    // eemaldame üleliigse mälu
    /*float * temp = realloc( A , sizeof(float) * i );
    if( temp == NULL )
    {
        printf("Ei õnnestunud mälu eraldada.\n");
    }
    A = temp;*/

    return 0;   // näitab, et sisestus oli edukas
}

float power(float a, int b)
{
    if( b = 0 ) return 1;
    else
    {
        return a*power( a, b -1);
    }
}

void tootlus(float * A , float * B , float * K , float X, int n, int m, int * l)
{
    *K = 0;
    i = 1;
    while( i  < n && i < m )
    {
        *(K + i) =
        ( *(K + i - 1) * (*(A + i)) * power(X,i)) /
        (power(*(A + i),2) + power(*(B + i),2));
        if(DEBUG == 2) printf("%lf\n",*(K+i));
        i++;
    }
}

int main(void)
{
    float A[8];
    float B[6];
    float K[6];
    int n = 8;  // näitab, mitu elementi on massiivis A
    int m = 6;  // näitab, mitu elementi on massiivis B
    int l = 6;  // massiivi K elementide arv
    float X = 1;
    sisestus( A,&n, massiivAFailiNimi);
    sisestus( B,&m, massiivBFailiNimi);
    tootlus(A,B,K,X,n,m,&l);

    return 0;
}
